function [A,B,C,D] = solveABCD(k)
global  g H rhow h rhoi G nu w w2 
    w2 = w*w;
    if k(2)<0
        k(2) = -10000;
    end    
    k  = k(1) + 1i*k(2);
    ve = nu + 1i*G/rhoi/w; 
    N  = w + 2*1i*k^2*ve;    %% 
    
    a  = sqrt(k^2 - 1i*w/ve);
    Sk = sinh(k*h);
    Ck = cosh(k*h);    
    Sa = sinh(a*h);
    Ca = cosh(a*h);     
  %  implicit dispersion relation
    M  = (rhow/rhoi-1)*g*k - rhow/rhoi*w2/tanh(k*H);  % g*k*(h/g),  k' = k*h   
    W  = [         0,          2*1i*k^2,       a^2+k^2,     0;
    N*w,  M, -1i*M,  2*k*a*w*ve     
    2*1i*k^2*Sk, 2*1i*k^2*Ck,  (a^2+k^2)*Ca,  (a^2+k^2)*Sa;
        N*w*Ck-g*k*Sk,  N*w*Sk-g*k*Ck,  1i*g*k*Ca+2*k*a*w*ve*Sa, 1i*g*k*Sa+2*k*a*w*ve*Ca;
        ];   
    
    [U S V] = svd(W);
    
    A = V(1,4)/V(1,4);
    B = V(2,4)/V(1,4);
    C = V(3,4)/V(1,4);
    D = V(4,4)/V(1,4);
end